import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class markovloveplus extends PApplet {


HashMap bigmap = new HashMap();

String buffer = "";


String a, b;

Pos posA = new Pos(10,250);
Pos posB;

float lineHeight = 24;
String currentLine;// = "";
String currentLineDisplay; //= "";

ArrayList oldLines ;
ArrayList oldLinesDisplay ;
HashSet movers ;

pile p;

boolean robot = false;

int saveMsgBright = 0;
String saveMsg = "";


public void setup(){
  size(500,500);
  frameRate(60);
  textFont(loadFont("ARBERKLEY-24.vlw"));

  String lines[] = loadStrings("words2004.txt");

  for(int i = 0; i < lines.length; i++){
    String parts[] = lines[i].split("\t");
    bigmap.put(parts[0]+"\t"+parts[1], new pile(parts));

  }

  String seedparts[] = lines[PApplet.parseInt(random(lines.length))].split("\t");
  a = seedparts[0];
  b = seedparts[1];

  posB = new Pos(posA.x+ textWidth(a+" "), posA.y);

startAgain();
  doFirst();
}



public void doFirst(){
  String key = a+"\t"+b;
  p = (pile)bigmap.get(key);
  p.showme();


}
public void doNext(String next){
  a = b;
  b = next;

  String key = a+"\t"+b;
  p = (pile)bigmap.get(key);
  p.showme();

}

public void savePoem(){
       String filename = "poem"+new Date().getTime()+".txt";
/*     int filecount = 0;
     while(new File(filename).exists()){
        filecount ++;
       filename = "poem"+filecount+".txt"; 
       println("!!!!");
     }*/
      String []ottarr = new String[oldLines.size()+1];
      for(int i = 0; i < ottarr.length-1;i++){
         ottarr[i] = (String)oldLines.get(i);
      }
      ottarr[ottarr.length-1] = currentLine;
      saveStrings(filename, ottarr);
      
      saveMsgBright = 255;
      saveMsg = "SAVED "+filename;
     
}

public void startAgain(){
   currentLine = a+" "+b;
 currentLineDisplay = currentLine;

 oldLines = new ArrayList();
 oldLinesDisplay = new ArrayList();
 movers = new HashSet();
}


public void keyPressed()  {
   if(key == 's' || key == 'S'){
      savePoem();
      startAgain();
   } 
   if(key == 'c' || key == 'C'){
      startAgain();
   } 
   if(key == 'r' || key == 'R'){
      robot = true; 
   }
}

public void draw(){
  background(200);
  //text(a,posA.x,posA.y);
  //text(b,posB.x,posB.y);
  fill(0);
  for(int i = 0; i < oldLinesDisplay.size(); i++){
    String s = (String)oldLines.get(i);
    text(s, 0,(i+1) * lineHeight);
  }  
  float currentLineDisplayY = (oldLinesDisplay.size() +1)* lineHeight;

  text(currentLineDisplay,0,currentLineDisplayY);

  p.draw();

  Iterator i = movers.iterator();
  while(i.hasNext()){
    PosMover m = (PosMover)i.next();
    boolean done = m.move();
    
    if(done){
      addInWord(m.word,currentLineDisplay,oldLinesDisplay,true);
      i.remove(); 
    } 
    else {
      m.draw(); 
    }

  }
 
 
   if(robot == true){
      if((oldLines.size() +2)* lineHeight >= 500){
         robot = false;
      }  
     if(frameCount % 10 == 5){

     mouseX = 300;
     mouseY = PApplet.parseInt(random(height));
     }
     if(frameCount % 10 == 0){
        mouseReleased();
     } 
   } 
   
   
   if(saveMsgBright > 0){
       saveMsgBright-=2;
       fill(saveMsgBright,0,0);
       text(saveMsg,100,200);
   }
   
  

}


public Pos addInWord(String newWord,String cLine, ArrayList oLines, boolean displayOnly){
   float newX=0,newY=0;
     if(textWidth(cLine + " "+newWord) > 250){
      newX = 0;
      newY = (oldLines.size() +2)*lineHeight;
      oLines.add(cLine);
    
    
      if(displayOnly){
        currentLineDisplay = newWord;
      } else {
      currentLine = newWord;
      }
    } 
    else {
      newX = textWidth(cLine + " ");
      newY = (oLines.size() +1)*lineHeight;
      if(displayOnly){
        currentLineDisplay += " "+newWord; 
      } else {
         currentLine += " "+newWord; 
      }

    } 
    return new Pos(newX,newY);
}


public void mouseReleased(){
  if(mouseX > 250){
    String newWord = p.click();
   


    Pos whereTo = addInWord(newWord,currentLine,oldLines,false);
    
    movers.add(new PosMover(newWord,new Pos(mouseX,mouseY),  whereTo));
    doNext(newWord);

  }
}





class pile {

  public void showme(){
    //     println("KEY:::: "+a+" "+b+"--"); 
  }

  String a;
  String b;
  int uniqs; 
  int tot;
  int upto;
  ArrayList valWords = new ArrayList();
  pile(String []parts){
    a = parts[0];
    b = parts[1];
    uniqs = Integer.parseInt(parts[2]);
    tot = Integer.parseInt(parts[3]);

    upto = 0;
    for(int i = 0; i < uniqs; i++){
      String word = parts[4 + (i * 2)];
      int count = Integer.parseInt(parts[5 + (i * 2)]);
      upto += count;
      valWords.add(new valAndWord(upto,word,count));

    }
    float lastBottom = 0;
    for(int i = 0; i < valWords.size();i++){
      valAndWord  v= (valAndWord) valWords.get(i);
      float thisHeight = (v.amount * 500) / upto;                
      v.boxtop = lastBottom;
      v.boxheight = thisHeight;

      float mid = lastBottom + (thisHeight / 2.0f);
      lastBottom += thisHeight;
    }



  } 



  public void draw(){
    int redo = -1;
    for(int i = 0; i < valWords.size();i++){
      valAndWord  v= (valAndWord) valWords.get(i);

      fill(255);
      if(mouseX > 250 && mouseY >= v.boxtop && mouseY < v.boxtop+v.boxheight){
        redo = i;
      }
      rect(250,v.boxtop,250,v.boxheight);
      float mid = v.boxtop + (v.boxheight/2.0f)+12;
      fill(0);
      text(v.word,260,mid);

    }
    if(redo != -1){
      valAndWord  v= (valAndWord) valWords.get(redo);
      fill(255,200,200); 
      float doheight = max(24,v.boxheight);
      float dotop=min(v.boxtop,476);
      rect(250,dotop,250,doheight);

      fill(200,0,0);
      float mid =dotop + (doheight/2.0f)+12;
      text(v.word,260,mid);


    }



  }


  public String click(){
    for(int i = 0; i < valWords.size();i++){
      valAndWord  v= (valAndWord) valWords.get(i);

      if(mouseX > 250 && mouseY >= v.boxtop && mouseY < v.boxtop+v.boxheight){
        return v.word;
      }

    }
    return "";
  }


  public String pickWord(){
    int r = PApplet.parseInt(random(upto))+1;

    for(int i = 0; i < valWords.size();i++){
      valAndWord  v= (valAndWord) valWords.get(i);
      if(v.val >= r){
        return v.word;
      } 
    }
    return "!!!!";
  }  
}

class valAndWord{
  int val;
  String word;
  float amount;
  float boxtop;
  float boxheight;
  valAndWord(int val, String word, float amount){
    this.val = val;
    this.word = word;
    this.amount = amount;
  }

}


class Pos{
  float x, y;
  Pos(float x, float y){
    this.x = x;
    this.y = y; 
  }
}

class PosMover {
  Pos startPos;
  Pos endPos;
  int TOTALSTEPS = 20;
  int currentStep = 0;
  String word;
  PosMover(String word, Pos startPos,Pos endPos){
    this.startPos = startPos;
    this.endPos = endPos;
    this.word = word;

  }   
  public boolean move(){ //return true when done
    currentStep++; 
    if(currentStep >= TOTALSTEPS){
      return true; 
    } 
    return false;
  }
  public void draw(){
    text(word,
    (endPos.x * currentStep / TOTALSTEPS)  + startPos.x * (TOTALSTEPS - currentStep) / TOTALSTEPS   ,
    (endPos.y * currentStep / TOTALSTEPS)  + startPos.y * (TOTALSTEPS - currentStep) / TOTALSTEPS );
  }

}


  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#D4D0C8", "markovloveplus" });
  }
}
